//
//  ViewController.m
//  KuroobiCam
//
//  Created by matsumoto keiji on 2013/11/09.
//  Copyright (c) 2013年 matsumoto keiji. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()

@end

@implementation ViewController

#define IMAGE_COUNT 3
#define FILE_PLEFIX @"borraji"

- (void)viewDidLoad
{
    [super viewDidLoad];
	self.imageNumber = arc4random() % IMAGE_COUNT + 1;
	UIImage *mixedImage = [UIImage imageNamed:[NSString stringWithFormat:@"%@%dB.png",FILE_PLEFIX,(int)self.imageNumber]];
	self.o_imageView.image = mixedImage;
	
	UIImage *iconImage = [UIImage imageNamed:[NSString stringWithFormat:@"%@_icon%d.png",FILE_PLEFIX,(int)self.imageNumber]];
	self.o_iconImageView.image = iconImage;
	self.picImage = nil;
	
	if ([[UIScreen mainScreen] bounds].size.height != 568){
		self.o_imageView.frame = [General moveControllRect:self.o_imageView.frame diff:CGRectMake(-20, 0, 0,0)];
	}

}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}
- (NSUInteger)supportedInterfaceOrientations{
    return UIInterfaceOrientationMaskLandscape;
}
- (BOOL)shouldAutorotate {
    return YES;
}

//-------------------------
//撮影
//-------------------------
- (IBAction)tapCamera:(id)sender {
    // カメラが利用できるか確認
    if([UIImagePickerController isSourceTypeAvailable:UIImagePickerControllerSourceTypeCamera]) {
        
        MyImagePickerController *imagePickerController = [[MyImagePickerController alloc] init];
        // カメラかライブラリからの読み込み指定。カメラを指定
        [imagePickerController setSourceType:UIImagePickerControllerSourceTypeCamera];
		
        // トリミングなどを行うか否か
        [imagePickerController setAllowsEditing:NO];
        // Delegateをセット
        imagePickerController.delegate = self;
		
		//位置はズレるけど精密に合わせるのめんどいのでそのまま
		UIImage *mixedImage = [UIImage imageNamed:[NSString stringWithFormat:@"%@%dc.png",FILE_PLEFIX,(int)self.imageNumber]];
		UIImageView *imageView = [[UIImageView alloc]initWithImage:mixedImage];
		
		[imagePickerController.view addSubview:imageView];
		if ([[UIScreen mainScreen] bounds].size.height == 568){
			imageView.frame = [General moveControllRect:imageView.frame diff:CGRectMake(0, 47, 0,0)];
		}
		else {
			imageView.frame = [General moveControllRect:imageView.frame diff:CGRectMake(0, 4, 0,0)];
		}
        // アニメーションをしてカメラUIを起動
        [self presentViewController:imagePickerController animated:YES completion:nil];
    }

}

//-------------------------
//保存
//-------------------------
- (IBAction)tapSave:(id)sender {
	//イメージを保存
	UIImageWriteToSavedPhotosAlbum(self.o_imageView.image,self,nil,NULL);
	[General showMsg:@"保存しました。"];
}



//-------------------------
//Facebookに投稿
//-------------------------
- (IBAction)tapFB:(id)sender {
	SLComposeViewController *facebookPostVC = [SLComposeViewController composeViewControllerForServiceType:SLServiceTypeFacebook];
	[facebookPostVC setInitialText:[NSString stringWithFormat:@"[%@から投稿！ #borracam ] ",[[NSBundle mainBundle] objectForInfoDictionaryKey: @"CFBundleDisplayName"]]];
	[facebookPostVC addImage:self.o_imageView.image];
	[self presentViewController:facebookPostVC animated:YES completion:nil];
}


//-------------------------
//ツイッターに投稿
//-------------------------
- (IBAction)tapTwitter:(id)sender {
	SLComposeViewController *twitterPostVC = [SLComposeViewController composeViewControllerForServiceType:SLServiceTypeTwitter];
	[twitterPostVC setInitialText:[NSString stringWithFormat:@"[%@から投稿！ #borracam ] ",[[NSBundle mainBundle] objectForInfoDictionaryKey: @"CFBundleDisplayName"]]];
	[twitterPostVC addImage:self.o_imageView.image];
	[self presentViewController:twitterPostVC animated:YES completion:nil];
	
}

//-------------------------
//レイヤー切替
//-------------------------
- (IBAction)tapRight:(id)sender {
	self.imageNumber++;
	if(self.imageNumber > IMAGE_COUNT) self.imageNumber = 1;
	
	UIImage *iconImage = [UIImage imageNamed:[NSString stringWithFormat:@"%@_icon%d.png",FILE_PLEFIX,(int)self.imageNumber]];
	self.o_iconImageView.image = iconImage;
	
	if(self.picImage) [self mixedImages:self.picImage];
	else {
		UIImage *mixedImage = [UIImage imageNamed:[NSString stringWithFormat:@"%@%dB.png",FILE_PLEFIX,(int)self.imageNumber]];
		self.o_imageView.image = mixedImage;
	}
}


//-------------------------
//撮影終了デリゲート
//-------------------------
- (void)imagePickerController:(UIImagePickerController*)picker
        didFinishPickingImage:(UIImage*)image
				  editingInfo:(NSDictionary*)editingInfo
{
	DLog(@"didFinishPickingImage");
	
	// カメラUIを閉じる
    [self dismissViewControllerAnimated:YES completion:nil];
	self.picImage = image;
	[self mixedImages:image];
}

//-------------------------
//合成
//-------------------------
- (void)mixedImages:(UIImage*)image
{
	
	//[self presentModalViewController:view animated:YES];
	
	CGRect imageRect = CGRectMake(0.0f, 0.0f, 640.0f, 480.0f);;
	DLog(@"size:%f %f",image.size.width,image.size.height);
	
	
	//NSString *imageFilename = [[NSBundle bundleForClass:[self class]] pathForResource:@"borraji1" ofType:@"png"];
	UIImage *mixedImage = [UIImage imageNamed:[NSString stringWithFormat:@"%@%dB.png",FILE_PLEFIX,(int)self.imageNumber]];
	
	
	//カメラを縦位置にした場合は画像が潰れます。面倒なのでそこらへんの処理は省略。適当に改造してください。
	
	
	// グラフィックスコンテキストを作る
	UIGraphicsBeginImageContext(imageRect.size);
	
	//CGContextRef context = UIGraphicsGetCurrentContext();
	
    // 画像を縮小して描画する
	[image drawInRect:imageRect];
	[mixedImage drawInRect:imageRect];
	
	
    // 描画した画像を取得する
	UIImage *shrinkedImage = UIGraphicsGetImageFromCurrentImageContext();
    UIGraphicsEndImageContext();
	
	
	self.o_imageView.image = shrinkedImage;
	return;
	
	
}



@end
